package net.rmi.rjs.fc.ssinstaller;


import java.io.*;
import gui.JInfoFrame;
import java.util.Hashtable;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import bookExamples.ch15Streams.Unzipper;
import net.web.UrlUtils;

public class SSInstallerUtil{

  //Screen saver directory at users local pc	
  protected static final String SS_HOME = "ss_home";;
  
  //Screen saver name 
  protected static final String SS_NAME = "ss_name";
  
  //Screen saver URL
  protected static final String SS_URL = "ss_url";
  
//Screen saver URL for Windows
  protected static final String SS_WIN_URL = "ss_win_url";
  
//Screen saver URL for Windows
  protected static final String SS_UNIX_URL = "ss_unix_url";
  
  //jar name
  protected static final String  JAR_NAME = "jar_name";
  
  //Screen saver URL
  private static final String INSTALL_PROPERTIES_FILE_NAME = "install.properties";
  
  //properties
  protected static Hashtable properties = new Hashtable();
  
  //screensaver installer properties file. This file must be located 
  //in the same jar file as the installer class
  private static File ss_install_proper_file = new File(INSTALL_PROPERTIES_FILE_NAME);
  
   
   protected static JInfoFrame jif;

    public SSInstallerUtil() {    	
    }


public static void downloadScreenSaverJar(File outputJarFile, String urlStr) throws IOException {

	URL screenSaverUrl = getResourceUrl(urlStr);
	UrlUtils.getUrl(screenSaverUrl, outputJarFile);

}

private static URL getResourceUrl(String urlStr) throws MalformedURLException {
    URL screenSaverUrl= new URL(urlStr);
    return screenSaverUrl;
}

public static void uncompressScreenSaverJar(File jarFile){
    Unzipper.uncompressJarFile(jarFile);
    jarFile.deleteOnExit();
}

public static String fileExists(File f){
	
	//Check that the file exists... Other wise exit program
	if (f.exists() == false){
		
		return "ERROR : Property file = " + f.toString() + " does not exists.";
	}
	return "";
}


/**Method: setProperties()
 * Description: Use to set hard coded properties. 
 * 				Optionally the method readPropertiesfile() can be use to set properties
 * 				from a properties file.
 */
public static String setProperties(){
	
	try{
		properties.put(SS_HOME, "ss");
		properties.put(SS_NAME, "rjssaver");
		properties.put(JAR_NAME, "rjssaverjar");
		properties.put(SS_WIN_URL, "http://www.myjavaserver.com/~fsophisco/thesis/libs/screensaver/win/rjssaverjar.jar");
		properties.put(SS_UNIX_URL, "http://www.myjavaserver.com/~fsophisco/thesis/libs/screensaver/unix/rjssaverjar.jar");
	}catch(Exception e){
		return "Error setting properties: " + e.toString();
	}

	return "";
}


/**
 * Method: readPropertiesfile()
 * Description: Use this method to read properties from a properties file.
 * 				The name of the file is stored in the static variable INSTALL_PROPERTIES_FILE_NAME.
 * 				It reads in this format: <property name>=<property value>
 * 				This file would be a resource file so it must be located with the .class files.
 * 				In this class we have additionaly created the method setProperties(), where the properties
 * 				values are hard coded.
 */
public static String readPropertiesfile(){
	
	String[] tokens = new String[2];
	String p_name;
	String p_value;
	String returnStr = "";
	
	properties.put(SS_HOME, "NONE");
	properties.put(SS_NAME, "NONE");
	properties.put(SS_WIN_URL, "NONE");
	properties.put(SS_UNIX_URL, "NONE");
	
	//Check existance
	if (fileExists(ss_install_proper_file) != ""){
		returnStr = "ERROR: Properties does not exists " + ss_install_proper_file.getAbsolutePath(); ;
		return returnStr;
	}
	
	//get resource as Input Stream
	InputStream input = SSInstallerUtil.class.getResourceAsStream(INSTALL_PROPERTIES_FILE_NAME);
	
	if (input == null)
	{
		returnStr = "ERROR : InputStream is null"; 
		return returnStr;
	}
	
	BufferedReader in
	   = new BufferedReader(new InputStreamReader(input));
	
	//Read Properties
	try{
		String line = in.readLine();
		while (line!= null)
		{	
			tokens = line.split("=", 2);
			p_name = tokens[0].trim();
			p_value = tokens[1].trim();
			if (properties.containsKey(p_name)){
				properties.put(p_name, p_value);
			}
			line = in.readLine();
		}	
		in.close();
	}catch(IOException e){
		returnStr = "ERROR : IOException: " + e.toString();
		return returnStr;
	}

	//Check that all properties are set
	
	if (checkProperties() == false)
	{
		returnStr = "ERROR : Missing Properties";
		return returnStr; 
	}

	return returnStr;
}

public static boolean checkProperties(){
	
	if (properties.containsValue("NONE"))
	{
		return false;
	}
	return true;
}

public static String getSSName(){
	
	return (String)properties.get(SS_NAME);
}

public static String getSSHome(){
	
	return (String)properties.get(SS_HOME);
}

public static String getSSWinUrl(){
	
	return (String)properties.get(SS_WIN_URL);
}

public static String getSSUnixUrl(){
	
	return (String)properties.get(SS_UNIX_URL);
}


public static void createDir(String path){
	File f = new File(path);
	f.mkdir();
}

public static String getJarName(){
	return (String)properties.get(JAR_NAME);
}

public static String getUserHome() {
        return System.getProperty("user.home");
 }

public static String getUserDir() {
        return System.getProperty("user.dir");
 }

public static String getJavaHome() {
        return System.getProperty("java.home");
 }

}//End of Class